unit EmbossMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.ExtDlgs, System.Types, System.UITypes,
  System.UIConsts, Math;

type
  TForm1 = class(TForm)
    FileOpen: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    EmbossBtn: TButton;
    SavePictureDialog1: TSavePictureDialog;
    FileSaveBtn: TButton;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    ColorEmbossBtn: TButton;
    RadioGroup1: TRadioGroup;
    LabeledEdit1: TLabeledEdit;
    SourceBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FileOpenClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
    procedure EmbossBtnClick(Sender: TObject);
    procedure ColorEmbossBtnClick(Sender: TObject);
    procedure SourceBtnClick(Sender: TObject);
  private
    { Private 錾 }
    procedure GrayEmboss;
    procedure ColorEmboss;
    procedure Light;          // G{XtB^[̐ݒ
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

type
  TPrgbarry = array[0..0] of Trgbtriple;      // 24rbgJ[R[h@32rbgpTRGBQuadArray
  Prgbarray  = ^TPrgbarry;                    // |C^[
                                              // z̃|C^[KvȂȂ̂ŁA1 [0..0]Ŗ肠܂B
implementation

{$R *.dfm}

const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

  RK    = 0.298912;                           // O[XP[PxW@
  GK    = 0.586611;                           // O[XP[PxW@
  BK    = 0.114478;                           // O[XP[PxW@

var
  InBitmap        : TBitmap;                  // rbg}bv
  OutBitmap       : TBitmap;
  GHeight, GWidth : integer;                  // \[X摜TCY
  BlueMat         : array of array of Byte;
  GreenMat        : array of array of Byte;
  RedMat          : array of array of Byte;
  YPPOS, YMPOS    : Integer;
  XPPOS, XMPOS    : Integer;
  EmbossK         : Double;

//================================================================
// ̌ʕݒ G{XtB^[̐ݒ
// obN̐FZxɂČʂtɂȂꍇ܂
// -1 0 0   0-1 0   0 0-1   0 0 0   1 0 0   0 1 0   0 0 1   0 0 0
//  0 0 0   0 0 0   0 0 0   1 0-1   0 0 0   0 0 0   0 0 0  -1 0 1
//  0 0 1   0 1 0   1 0 0   0 0 0   0 0-1   0-1 0  -1 0 0   0 0 0
//================================================================
procedure TForm1.Light;
var
  Check : Integer;
begin
  Val(LabeledEdit1.Text, EmbossK, Check);
  if (Check <> 0) or (EmbossK < 0) then EmbossK := 1;
  case RadioGroup1.ItemIndex of
    0 : begin         // 
      YPPOS :=  1;
      XPPOS :=  1;
      YMPOS := -1;
      XMPOS := -1;
    end;
    1 : begin         // 
      YPPOS :=  1;
      XPPOS :=  0;
      YMPOS := -1;
      XMPOS :=  0;
    end;
    2 : begin         // E
      YPPOS :=  1;
      XPPOS := -1;
      YMPOS := -1;
      XMPOS :=  1;
    end;
    3 : begin         // E
      YPPOS :=  0;
      XPPOS := -1;
      YMPOS :=  0;
      XMPOS :=  1;
    end;
    4 : begin         // E
      YPPOS := -1;
      XPPOS := -1;
      YMPOS :=  1;
      XMPOS :=  1;
    end;
    5 : begin         // 
      YPPOS := -1;
      XPPOS :=  0;
      YMPOS :=  1;
      XMPOS :=  0;
    end;
    6 : begin         // 
      YPPOS := -1;
      XPPOS :=  1;
      YMPOS :=  1;
      XMPOS := -1;
    end;
    7 : begin         // 
      YPPOS :=  0;
      XPPOS :=  1;
      YMPOS :=  0;
      XMPOS := -1;
    end;
  end;
end;

//=======================================
// O[̃G{X
// PxϊG{X
// -1 0 0
//  0 0 0 X W { 128
//  0 0 1
//=======================================
procedure TForm1.GrayEmboss;
var
  XX, YY  : Integer;
  PRGB    : Prgbarray;
  EmbD    : Smallint;
begin
// O[Pxϊ
  for YY := 0 to GHeight - 1 do begin
    PRGB := InBitmap.ScanLine[YY];
    for XX := 0 to GWidth - 1 do begin
      BlueMat[YY, XX] := Round(PRGB[XX].rgbtBlue  * BK +
                               PRGB[XX].rgbtGreen * GK +
                               PRGB[XX].rgbtRed   * RK);
    end;
  end;
// G{X
  for YY := 0 to GHeight - 1 do begin
    PRGB := OutBitmap.ScanLine[YY];
    for XX := 0 to GWidth - 1 do begin
      // ŊO͏Ȃ
      if (YY = 0) or (XX = 0) or (YY = GHeight - 1) or (XX = GWidth - 1) then
        EmbD := BlueMat[YY, XX]
      // G{X
      else begin
        EmbD := BlueMat[YY + YPPOS, XX + XPPOS] - BlueMat[YY + YMPOS, XX + XMPOS];
        EmbD := round(EmbD * EmbossK + 128);
        if EmbD > 255 then EmbD := 255;
        if EmbD < 0   then EmbD := 0;
      end;
      // OFlZbg
      PRGB[XX].rgbtBlue := EmbD;
      PRGB[XX].rgbtGreen := EmbD;
      PRGB[XX].rgbtRed := EmbD;
    end;
  end;
  Image1.Picture.Bitmap := OutBitmap;                // o͘gɏo
end;

//===================================
// J[̃G{X
// -1 0 0
//  0 0 0 ~ W { J[
//  0 0 1
//===================================
procedure TForm1.ColorEmboss;
var
  XX, YY  : Integer;
  PRGB    : Prgbarray;
  EmbB    : Smallint;
  EmbG    : Smallint;
  EmbR    : Smallint;
begin
  // OF̔zɕ
  for YY := 0 to GHeight - 1 do begin
    PRGB := InBitmap.ScanLine[YY];
    for XX := 0 to GWidth - 1 do begin
      BlueMat[YY, XX]   := PRGB[XX].rgbtBlue;
      GreenMat[YY, XX]  := PRGB[XX].rgbtGreen;
      RedMat[YY, XX]    := PRGB[XX].rgbtRed;
    end;
  end;
  // G{X
  for YY := 0 to GHeight - 1 do begin
    PRGB := OutBitmap.ScanLine[YY];
    for XX := 0 to GWidth - 1 do begin
      // ŊO͏Ȃ
      if (YY = 0) or (XX = 0) or (YY = GHeight - 1) or (XX = GWidth - 1) then begin
        EmbB := BlueMat[YY, XX];
        EmbG := GreenMat[YY, XX];
        EmbR := RedMat[YY, XX];
      end
      // OFG{X
      else begin
        // 
        EmbB := BlueMat[YY + YPPOS, XX + XPPOS] - BlueMat[YY + YMPOS, XX + XMPOS];
        EmbB := round(EmbB * EmbossK + BlueMat[YY, XX]);
        if EmbB > 255 then EmbB := 255;
        if EmbB < 0   then EmbB := 0;
        // 
        EmbG := GreenMat[YY + YPPOS, XX + XPPOS] - GreenMat[YY + YMPOS, XX + XMPOS];
        EmbG := round(EmbG * EmbossK + GreenMat[YY, XX]);
        if EmbG > 255 then EmbG := 255;
        if EmbG < 0   then EmbG := 0;
        // 
        EmbR := RedMat[YY + YPPOS, XX + XPPOS] - RedMat[YY + YMPOS, XX + XMPOS];
        EmbR := round(EmbR * EmbossK + RedMat[YY, XX]);
        if EmbR > 255 then EmbR := 255;
        if EmbR < 0   then EmbR := 0;
      end;
      // OFꂼ̒lZbg
      PRGB[XX].rgbtBlue  := EmbB;
      PRGB[XX].rgbtGreen := EmbG;
      PRGB[XX].rgbtRed   := EmbR;
    end;
  end;
  Image1.Picture.Bitmap := OutBitmap;                // o͘gɏo
end;

procedure TForm1.SourceBtnClick(Sender: TObject);
begin
  Image1.Picture.Bitmap := inBitmap;                // o͘gɏo
end;

procedure TForm1.ColorEmbossBtnClick(Sender: TObject);
begin
  Light;                                            // G{XtB^[̐ݒ
  ColorEmboss;                                      // J[G{X
  FileSaveBtn.Enabled   := True;
  SourceBtn.Enabled := True;
end;

procedure TForm1.EmbossBtnClick(Sender: TObject);
begin
  Light;                                            // G{XtB^[̐ݒ
  GrayEmboss;                                       // O[G{X
  FileSaveBtn.Enabled   := True;
  SourceBtn.Enabled := True;
end;

// t@C̃I[v@WIC@t@C̎ނ̂Ŏgp
procedure TForm1.FileOpenClick(Sender: TObject);
var
  WIC         : TWICImage;
  InFilename  : String;
begin
  EmbossBtn.Enabled  := False;
  ColorEmbossBtn.Enabled := False;
  FileSaveBtn.Enabled   := False;
  SourceBtn.Enabled := False;
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        InBitmap.Width    := GWidth;
        InBitmap.Height   := GHeight;
        InBitmap.Canvas.Draw(0, 0, WIC);                      // DrawInBitmapɓ͉摜ݒtH[}bg24rbgɕϊ܂
        Image1.Picture.Bitmap := InBitmap;
        OutBitmap.Width := GWidth;
        OutBitmap.Height:= GHeight;
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else Exit;
  Setlength(BlueMat,        GHeight, GWidth);
  Setlength(GreenMat,       GHeight, GWidth);
  Setlength(RedMat,         GHeight, GWidth);
  EmbossBtn.Enabled   := True;
  ColorEmbossBtn.Enabled := True;
end;

// t@C̃I[v
procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;                                            // gqɂt@CtH[}bgݒ
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;
//  SavePictureDialog1.DefaultExt := GraphicExtension(TWicImage);
  if not SavePictureDialog1.Execute then exit;
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
  if ExeStr = '' then begin                                                // gqȂ
    Findex := SavePictureDialog1.FilterIndex;                              // FilterIndexɂgq̐ݒ
    case Findex of
      1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');   // gq̐ݒ
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');   // gq̐ݒ
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');   // gq̐ݒ
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');   // gq̐ݒ
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');   // gq̐ݒ
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');   // gq̐ݒ
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;
  ExeStr := ExtractFileExt(Fname);                                         // gqo
  if not WFormatSet then begin                                             // gqɂt@CtH[}bgݒƊmF
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);                                      // t@Co
  if Length(FnameTop) = Length(ExeStr) then begin                          // t@C̒mF
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then                                                // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;                                                 // TWicImage
  try
    WIC.Assign(OutBitmap);                                                  // TWicImageɃrbg}bvf[^[t
    WIC.ImageFormat := WICF;                                               // ۑtH[}bgZbg
    WIC.SaveTofile(Fname);                                                 // t@C̏o
  finally
    WIC.Free;                                                              // TWicImage
  end;
end;

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  EmbossBtn.Enabled := False;
  ColorEmbossBtn.Enabled := False;
  FileSaveBtn.Enabled   := False;
  SourceBtn.Enabled := False;
  InBitmap      := TBitmap.Create;        // ͉摜p
  OutBitmap     := TBitmap.Create;        // 24rbgo͗p
  InBitmap.PixelFormat    := pf24bit;     // 24rbgJ[ɐݒ
  OutBitmap.PixelFormat   := pf24bit;     // 24rbgJ[ɐݒ
end;

// rbg}bv̉
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InBitmap.Free;
  OutBitmap.Free;
end;

end.
